----------------------------------------------------------------------
-- Created by Actel SmartDesign Thu Dec 29 14:20:58 2011
-- Testbench Template
-- This is a basic testbench that instantiates your design with basic 
-- clock and reset pins connected.  If your design has special
-- clock/reset or testbench driver requirements then you should 
-- copy this file and modify it. 
----------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity testbench is
end testbench;

architecture behavioral of testbench is

    constant SYSCLK_PERIOD : time := 100 ns;

    signal SYSCLK : std_logic := '0';
    signal NSYSRESET : std_logic := '0';

    component usbee_top_level
        -- ports
        port( 
            -- Inputs
            UART_0_RXD : in std_logic;
            MSS_RESET_N : in std_logic;
            MAINXIN : in std_logic;
            IO_0_PADIN : in std_logic;
            USB_CLK : in std_logic;

            -- Outputs
            EMC_CLK : out std_logic;
            EMC_CS0_N : out std_logic;
            EMC_CS1_N : out std_logic;
            EMC_OEN0_N : out std_logic;
            EMC_OEN1_N : out std_logic;
            EMC_RW_N : out std_logic;
            UART_0_TXD : out std_logic;
            EMC_AB : out std_logic_vector(25 downto 0);
            EMC_BYTEN : out std_logic_vector(1 downto 0);

            -- Inouts
            EMC_DB : inout std_logic_vector(15 downto 0);
            USB_DATA_PAD : inout std_logic_vector(7 downto 0)

        );
    end component;

begin

    process
        variable vhdl_initial : BOOLEAN := TRUE;

    begin
        if ( vhdl_initial ) then
            -- Assert Reset
            NSYSRESET <= '0';
            wait for ( SYSCLK_PERIOD * 10 );
            
            NSYSRESET <= '1';
            wait;
        end if;
    end process;

    -- 10MHz Clock Driver
    SYSCLK <= not SYSCLK after (SYSCLK_PERIOD / 2.0 );

    -- Instantiate Unit Under Test:  usbee_top_level
    usbee_top_level_0 : usbee_top_level
        -- port map
        port map( 
            -- Inputs
            UART_0_RXD => '0',
            MSS_RESET_N => NSYSRESET,
            MAINXIN => '0',
            IO_0_PADIN => '0',
            USB_CLK => SYSCLK,

            -- Outputs
            EMC_CLK =>  open,
            EMC_CS0_N =>  open,
            EMC_CS1_N =>  open,
            EMC_OEN0_N =>  open,
            EMC_OEN1_N =>  open,
            EMC_RW_N =>  open,
            UART_0_TXD =>  open,
            EMC_AB => open,
            EMC_BYTEN => open,

            -- Inouts
            EMC_DB => open,
            USB_DATA_PAD => open

        );

end behavioral;

